
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
import remote_failure
class link_oam_interface(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-interface - based on the path /interface/ethernet/link-oam-interface. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__enable','__allow_loopback','__remote_failure',)

  _yang_name = 'link-oam-interface'
  _rest_name = 'link-oam'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__remote_failure = YANGDynClass(base=remote_failure.remote_failure, is_container='container', presence=False, yang_name="remote-failure", rest_name="remote-failure", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Remote failure', u'cli-incomplete-command': None}}, namespace='urn:brocade.com:mgmt:brocade-dot3ah', defining_module='brocade-dot3ah', yang_type='container', is_config=True)
    self.__enable = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'active': {'value': 1}, u'passive': {'value': 2}},), is_leaf=True, yang_name="enable", rest_name="enable", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Enable link-oam with active/passive mode', u'cli-full-no': None}}, namespace='urn:brocade.com:mgmt:brocade-dot3ah', defining_module='brocade-dot3ah', yang_type='enumeration', is_config=True)
    self.__allow_loopback = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="allow-loopback", rest_name="allow-loopback", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Allow Link OAM loopback', u'cli-full-no': None}}, namespace='urn:brocade.com:mgmt:brocade-dot3ah', defining_module='brocade-dot3ah', yang_type='empty', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'interface', u'ethernet', u'link-oam-interface']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'interface', u'Ethernet', u'link-oam']

  def _get_enable(self):
    """
    Getter method for enable, mapped from YANG variable /interface/ethernet/link_oam_interface/enable (enumeration)
    """
    return self.__enable
      
  def _set_enable(self, v, load=False):
    """
    Setter method for enable, mapped from YANG variable /interface/ethernet/link_oam_interface/enable (enumeration)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_enable is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_enable() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'active': {'value': 1}, u'passive': {'value': 2}},), is_leaf=True, yang_name="enable", rest_name="enable", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Enable link-oam with active/passive mode', u'cli-full-no': None}}, namespace='urn:brocade.com:mgmt:brocade-dot3ah', defining_module='brocade-dot3ah', yang_type='enumeration', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """enable must be of a type compatible with enumeration""",
          'defined-type': "brocade-dot3ah:enumeration",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'active': {'value': 1}, u'passive': {'value': 2}},), is_leaf=True, yang_name="enable", rest_name="enable", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Enable link-oam with active/passive mode', u'cli-full-no': None}}, namespace='urn:brocade.com:mgmt:brocade-dot3ah', defining_module='brocade-dot3ah', yang_type='enumeration', is_config=True)""",
        })

    self.__enable = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_enable(self):
    self.__enable = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'active': {'value': 1}, u'passive': {'value': 2}},), is_leaf=True, yang_name="enable", rest_name="enable", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Enable link-oam with active/passive mode', u'cli-full-no': None}}, namespace='urn:brocade.com:mgmt:brocade-dot3ah', defining_module='brocade-dot3ah', yang_type='enumeration', is_config=True)


  def _get_allow_loopback(self):
    """
    Getter method for allow_loopback, mapped from YANG variable /interface/ethernet/link_oam_interface/allow_loopback (empty)
    """
    return self.__allow_loopback
      
  def _set_allow_loopback(self, v, load=False):
    """
    Setter method for allow_loopback, mapped from YANG variable /interface/ethernet/link_oam_interface/allow_loopback (empty)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_allow_loopback is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_allow_loopback() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="allow-loopback", rest_name="allow-loopback", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Allow Link OAM loopback', u'cli-full-no': None}}, namespace='urn:brocade.com:mgmt:brocade-dot3ah', defining_module='brocade-dot3ah', yang_type='empty', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """allow_loopback must be of a type compatible with empty""",
          'defined-type': "empty",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="allow-loopback", rest_name="allow-loopback", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Allow Link OAM loopback', u'cli-full-no': None}}, namespace='urn:brocade.com:mgmt:brocade-dot3ah', defining_module='brocade-dot3ah', yang_type='empty', is_config=True)""",
        })

    self.__allow_loopback = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_allow_loopback(self):
    self.__allow_loopback = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="allow-loopback", rest_name="allow-loopback", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'cli-full-command': None, u'info': u'Allow Link OAM loopback', u'cli-full-no': None}}, namespace='urn:brocade.com:mgmt:brocade-dot3ah', defining_module='brocade-dot3ah', yang_type='empty', is_config=True)


  def _get_remote_failure(self):
    """
    Getter method for remote_failure, mapped from YANG variable /interface/ethernet/link_oam_interface/remote_failure (container)
    """
    return self.__remote_failure
      
  def _set_remote_failure(self, v, load=False):
    """
    Setter method for remote_failure, mapped from YANG variable /interface/ethernet/link_oam_interface/remote_failure (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_remote_failure is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_remote_failure() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=remote_failure.remote_failure, is_container='container', presence=False, yang_name="remote-failure", rest_name="remote-failure", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Remote failure', u'cli-incomplete-command': None}}, namespace='urn:brocade.com:mgmt:brocade-dot3ah', defining_module='brocade-dot3ah', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """remote_failure must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=remote_failure.remote_failure, is_container='container', presence=False, yang_name="remote-failure", rest_name="remote-failure", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Remote failure', u'cli-incomplete-command': None}}, namespace='urn:brocade.com:mgmt:brocade-dot3ah', defining_module='brocade-dot3ah', yang_type='container', is_config=True)""",
        })

    self.__remote_failure = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_remote_failure(self):
    self.__remote_failure = YANGDynClass(base=remote_failure.remote_failure, is_container='container', presence=False, yang_name="remote-failure", rest_name="remote-failure", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Remote failure', u'cli-incomplete-command': None}}, namespace='urn:brocade.com:mgmt:brocade-dot3ah', defining_module='brocade-dot3ah', yang_type='container', is_config=True)

  enable = __builtin__.property(_get_enable, _set_enable)
  allow_loopback = __builtin__.property(_get_allow_loopback, _set_allow_loopback)
  remote_failure = __builtin__.property(_get_remote_failure, _set_remote_failure)


  _pyangbind_elements = {'enable': enable, 'allow_loopback': allow_loopback, 'remote_failure': remote_failure, }


