
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
import bd_add
import evpn_bd
class bridge_domain(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-common-def - based on the path /routing-system/evpn-config/evpn/evpn-instance/bridge-domain. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__bd_add','__evpn_bd',)

  _yang_name = 'bridge-domain'
  _rest_name = 'bridge-domain'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__bd_add = YANGDynClass(base=bd_add.bd_add, is_container='container', presence=False, yang_name="bd-add", rest_name="", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Add/Remove bridge domains from EVPN Instance', u'cli-drop-node-name': None}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='container', is_config=True)
    self.__evpn_bd = YANGDynClass(base=YANGListType("bd_number",evpn_bd.evpn_bd, yang_name="evpn-bd", rest_name="evpn-bd", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='bd-number', extensions={u'tailf-common': {u'info': u'Bridge Domain configuration', u'cli-no-key-completion': None, u'callpoint': u'EvpnBDConfig', u'cli-suppress-list-no': None, u'cli-drop-node-name': None, u'cli-suppress-key-abbreviation': None, u'cli-full-command': None, u'cli-full-no': None, u'cli-mode-name': u'evpn-bridge-domain-$(bd-number)'}}), is_container='list', yang_name="evpn-bd", rest_name="evpn-bd", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Bridge Domain configuration', u'cli-no-key-completion': None, u'callpoint': u'EvpnBDConfig', u'cli-suppress-list-no': None, u'cli-drop-node-name': None, u'cli-suppress-key-abbreviation': None, u'cli-full-command': None, u'cli-full-no': None, u'cli-mode-name': u'evpn-bridge-domain-$(bd-number)'}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='list', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'routing-system', u'evpn-config', u'evpn', u'evpn-instance', u'bridge-domain']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'evpn', u'evpn-instance', u'bridge-domain']

  def _get_bd_add(self):
    """
    Getter method for bd_add, mapped from YANG variable /routing_system/evpn_config/evpn/evpn_instance/bridge_domain/bd_add (container)
    """
    return self.__bd_add
      
  def _set_bd_add(self, v, load=False):
    """
    Setter method for bd_add, mapped from YANG variable /routing_system/evpn_config/evpn/evpn_instance/bridge_domain/bd_add (container)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_bd_add is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_bd_add() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=bd_add.bd_add, is_container='container', presence=False, yang_name="bd-add", rest_name="", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Add/Remove bridge domains from EVPN Instance', u'cli-drop-node-name': None}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='container', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """bd_add must be of a type compatible with container""",
          'defined-type': "container",
          'generated-type': """YANGDynClass(base=bd_add.bd_add, is_container='container', presence=False, yang_name="bd-add", rest_name="", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Add/Remove bridge domains from EVPN Instance', u'cli-drop-node-name': None}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='container', is_config=True)""",
        })

    self.__bd_add = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_bd_add(self):
    self.__bd_add = YANGDynClass(base=bd_add.bd_add, is_container='container', presence=False, yang_name="bd-add", rest_name="", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Add/Remove bridge domains from EVPN Instance', u'cli-drop-node-name': None}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='container', is_config=True)


  def _get_evpn_bd(self):
    """
    Getter method for evpn_bd, mapped from YANG variable /routing_system/evpn_config/evpn/evpn_instance/bridge_domain/evpn_bd (list)

    YANG Description: EVPN instance bridge domain config
    """
    return self.__evpn_bd
      
  def _set_evpn_bd(self, v, load=False):
    """
    Setter method for evpn_bd, mapped from YANG variable /routing_system/evpn_config/evpn/evpn_instance/bridge_domain/evpn_bd (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_evpn_bd is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_evpn_bd() directly.

    YANG Description: EVPN instance bridge domain config
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("bd_number",evpn_bd.evpn_bd, yang_name="evpn-bd", rest_name="evpn-bd", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='bd-number', extensions={u'tailf-common': {u'info': u'Bridge Domain configuration', u'cli-no-key-completion': None, u'callpoint': u'EvpnBDConfig', u'cli-suppress-list-no': None, u'cli-drop-node-name': None, u'cli-suppress-key-abbreviation': None, u'cli-full-command': None, u'cli-full-no': None, u'cli-mode-name': u'evpn-bridge-domain-$(bd-number)'}}), is_container='list', yang_name="evpn-bd", rest_name="evpn-bd", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Bridge Domain configuration', u'cli-no-key-completion': None, u'callpoint': u'EvpnBDConfig', u'cli-suppress-list-no': None, u'cli-drop-node-name': None, u'cli-suppress-key-abbreviation': None, u'cli-full-command': None, u'cli-full-no': None, u'cli-mode-name': u'evpn-bridge-domain-$(bd-number)'}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='list', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """evpn_bd must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("bd_number",evpn_bd.evpn_bd, yang_name="evpn-bd", rest_name="evpn-bd", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='bd-number', extensions={u'tailf-common': {u'info': u'Bridge Domain configuration', u'cli-no-key-completion': None, u'callpoint': u'EvpnBDConfig', u'cli-suppress-list-no': None, u'cli-drop-node-name': None, u'cli-suppress-key-abbreviation': None, u'cli-full-command': None, u'cli-full-no': None, u'cli-mode-name': u'evpn-bridge-domain-$(bd-number)'}}), is_container='list', yang_name="evpn-bd", rest_name="evpn-bd", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Bridge Domain configuration', u'cli-no-key-completion': None, u'callpoint': u'EvpnBDConfig', u'cli-suppress-list-no': None, u'cli-drop-node-name': None, u'cli-suppress-key-abbreviation': None, u'cli-full-command': None, u'cli-full-no': None, u'cli-mode-name': u'evpn-bridge-domain-$(bd-number)'}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='list', is_config=True)""",
        })

    self.__evpn_bd = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_evpn_bd(self):
    self.__evpn_bd = YANGDynClass(base=YANGListType("bd_number",evpn_bd.evpn_bd, yang_name="evpn-bd", rest_name="evpn-bd", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='bd-number', extensions={u'tailf-common': {u'info': u'Bridge Domain configuration', u'cli-no-key-completion': None, u'callpoint': u'EvpnBDConfig', u'cli-suppress-list-no': None, u'cli-drop-node-name': None, u'cli-suppress-key-abbreviation': None, u'cli-full-command': None, u'cli-full-no': None, u'cli-mode-name': u'evpn-bridge-domain-$(bd-number)'}}), is_container='list', yang_name="evpn-bd", rest_name="evpn-bd", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Bridge Domain configuration', u'cli-no-key-completion': None, u'callpoint': u'EvpnBDConfig', u'cli-suppress-list-no': None, u'cli-drop-node-name': None, u'cli-suppress-key-abbreviation': None, u'cli-full-command': None, u'cli-full-no': None, u'cli-mode-name': u'evpn-bridge-domain-$(bd-number)'}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='list', is_config=True)

  bd_add = __builtin__.property(_get_bd_add, _set_bd_add)
  evpn_bd = __builtin__.property(_get_evpn_bd, _set_evpn_bd)


  _pyangbind_elements = {'bd_add': bd_add, 'evpn_bd': evpn_bd, }


